Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.70.2.2
retrieving revision 1.70.2.3
diff -u -r1.70.2.2 -r1.70.2.3
--- squid/src/client_side.c	3 Sep 2002 10:29:38 -0000	1.70.2.2
+++ squid/src/client_side.c	5 Sep 2002 10:28:20 -0000	1.70.2.3
@@ -1142,571 +383,76 @@
     return 0;
 }
 
+static int
+clientRequestBodyTooLarge(int clen)
+{
+    if (0 == Config.maxRequestBodySize)
+	return 0;		/* disabled */
+    if (clen < 0)
+	return 0;		/* unknown, bug? */
+    if (clen > Config.maxRequestBodySize)
+	return 1;		/* too large */
+    return 0;
+}
 
 /*
- * filters out unwanted entries from original reply header
- * adds extra entries if we have more info than origin server
- * adds Squid specific entries
- */
-static void
-clientBuildReplyHeader(clientHttpRequest * http, HttpReply * rep)
-{
-    HttpHeader *hdr = &rep->header;
-    int is_hit = isTcpHit(http->log_type);
-    request_t *request = http->request;
-#if DONT_FILTER_THESE
-    /* but you might want to if you run Squid as an HTTP accelerator */
-    /* httpHeaderDelById(hdr, HDR_ACCEPT_RANGES); */
-    httpHeaderDelById(hdr, HDR_ETAG);
-#endif
-    httpHeaderDelById(hdr, HDR_PROXY_CONNECTION);
-    /* here: Keep-Alive is a field-name, not a connection directive! */
-    httpHeaderDelByName(hdr, "Keep-Alive");
-    /* remove Set-Cookie if a hit */
-    if (is_hit)
-	httpHeaderDelById(hdr, HDR_SET_COOKIE);
-    /* handle Connection header */
-    if (httpHeaderHas(hdr, HDR_CONNECTION)) {
-	/* anything that matches Connection list member will be deleted */
-	String strConnection = httpHeaderGetList(hdr, HDR_CONNECTION);
-	const HttpHeaderEntry *e;
-	HttpHeaderPos pos = HttpHeaderInitPos;
-	/*
-	 * think: on-average-best nesting of the two loops (hdrEntry
-	 * and strListItem) @?@
-	 */
-	/*
-	 * maybe we should delete standard stuff ("keep-alive","close")
-	 * from strConnection first?
-	 */
-	while ((e = httpHeaderGetEntry(hdr, &pos))) {
-	    if (strListIsMember(&strConnection, strBuf(e->name), ','))
-		httpHeaderDelAt(hdr, pos);
-	}
-	httpHeaderDelById(hdr, HDR_CONNECTION);
-	stringClean(&strConnection);
-    }
-    /*
-     * Add a estimated Age header on cache hits.
-     */
-    if (is_hit) {
-	/*
-	 * Remove any existing Age header sent by upstream caches
-	 * (note that the existing header is passed along unmodified
-	 * on cache misses)
-	 */
-	httpHeaderDelById(hdr, HDR_AGE);
-	/*
-	 * This adds the calculated object age. Note that the details of the
-	 * age calculation is performed by adjusting the timestamp in
-	 * storeTimestampsSet(), not here.
-	 *
-	 * BROWSER WORKAROUND: IE sometimes hangs when receiving a 0 Age
-	 * header, so don't use it unless there is a age to report. Please
-	 * note that Age is only used to make a conservative estimation of
-	 * the objects age, so a Age: 0 header does not add any useful
-	 * information to the reply in any case.
-	 */
-	if (NULL == http->entry)
-	    (void) 0;
-	else if (http->entry->timestamp < 0)
-	    (void) 0;
-	else if (http->entry->timestamp < squid_curtime) {
-	    httpHeaderPutInt(hdr, HDR_AGE,
-		squid_curtime - http->entry->timestamp);
-	    /* Signal old objects.  NB: rfc 2616 is not clear, by implication, on 
-	     * whether we should do this to all responses, or only cache hits.
-	     * 14.46 states it ONLY applys for heuristically caclulated 
-	     * freshness values, 13.2.4 doesn't specify the same limitation.
-	     * We interpret RFC 2616 under the combination.
-	     */
-	    /* TODO: if maxage or s-maxage is present, don't do this 
-	     */
-	    if (squid_curtime - http->entry->timestamp >= 86400) {
-		char tempbuf[512];
-		snprintf (tempbuf, sizeof(tempbuf), "%s %s %s", "113", ThisCache,
-		    "This cache hit is still fresh and more than 1 day old");
-		httpHeaderPutStr(hdr, HDR_WARNING, tempbuf);
-	    }
-	}
-	
-    }
-    /* Handle authentication headers */
-    if (request->auth_user_request)
-	authenticateFixHeader(rep, request->auth_user_request, request, http->flags.accel, 0);
-    /* Append X-Cache */
-    httpHeaderPutStrf(hdr, HDR_X_CACHE, "%s from %s",
-	is_hit ? "HIT" : "MISS", getMyHostname());
-#if USE_CACHE_DIGESTS
-    /* Append X-Cache-Lookup: -- temporary hack, to be removed @?@ @?@ */
-    httpHeaderPutStrf(hdr, HDR_X_CACHE_LOOKUP, "%s from %s:%d",
-	http->lookup_type ? http->lookup_type : "NONE",
-	getMyHostname(), getMyPort());
-#endif
-    if (httpReplyBodySize(request->method, rep) < 0) {
-	debug(33, 3) ("clientBuildReplyHeader: can't keep-alive, unknown body size\n");
-	request->flags.proxy_keepalive = 0;
-    }
-    /* Append Via */
-    {
-	LOCAL_ARRAY(char, bbuf, MAX_URL + 32);
-	String strVia = httpHeaderGetList(hdr, HDR_VIA);
-	snprintf(bbuf, sizeof(bbuf), "%d.%d %s",
-	    rep->sline.version.major,
-	    rep->sline.version.minor, ThisCache);
-	strListAdd(&strVia, bbuf, ',');
-	httpHeaderDelById(hdr, HDR_VIA);
-	httpHeaderPutStr(hdr, HDR_VIA, strBuf(strVia));
-	stringClean(&strVia);
-    }
-    /* Signal keep-alive if needed */
-    httpHeaderPutStr(hdr,
-	http->flags.accel ? HDR_CONNECTION : HDR_PROXY_CONNECTION,
-	request->flags.proxy_keepalive ? "keep-alive" : "close");
-#if ADD_X_REQUEST_URI
-    /*
-     * Knowing the URI of the request is useful when debugging persistent
-     * connections in a client; we cannot guarantee the order of http headers,
-     * but X-Request-URI is likely to be the very last header to ease use from a
-     * debugger [hdr->entries.count-1].
-     */
-    httpHeaderPutStr(hdr, HDR_X_REQUEST_URI,
-	http->entry->mem_obj->url ? http->entry->mem_obj->url : http->uri);
-#endif
-    httpHdrMangleList(hdr, request);
-}
-
-static HttpReply *
-clientBuildReply(clientHttpRequest * http, const char *buf, size_t size)
-{
-    HttpReply *rep = httpReplyCreate();
-    size_t k = headersEnd(buf, size);
-    if (k && httpReplyParse(rep, buf, k)) {
-	/* enforce 1.0 reply version */
-	httpBuildVersion(&rep->sline.version, 1, 0);
-	/* do header conversions */
-	clientBuildReplyHeader(http, rep);
-    } else {
-	/* parsing failure, get rid of the invalid reply */
-	httpReplyDestroy(rep);
-	rep = NULL;
-    }
-    return rep;
-}
-
-/*
- * clientCacheHit should only be called until the HTTP reply headers
- * have been parsed.  Normally this should be a single call, but
- * it might take more than one.  As soon as we have the headers,
- * we hand off to clientSendMoreData, clientProcessExpired, or
- * clientProcessMiss.
- */
-static void
-clientCacheHit(void *data, char *buf, ssize_t size)
-{
-    clientHttpRequest *http = data;
-    StoreEntry *e = http->entry;
-    MemObject *mem;
-    request_t *r = http->request;
-    debug(33, 3) ("clientCacheHit: %s, %d bytes\n", http->uri, (int) size);
-    if (http->entry == NULL) {
-	debug(33, 3) ("clientCacheHit: request aborted\n");
-	return;
-    } else if (size < 0) {
-	/* swap in failure */
-	debug(33, 3) ("clientCacheHit: swapin failure for %s\n", http->uri);
-	http->log_type = LOG_TCP_SWAPFAIL_MISS;
-	if ((e = http->entry)) {
-	    http->entry = NULL;
-	    storeUnregister(http->sc, e, http);
-	    http->sc = NULL;
-	    storeUnlockObject(e);
-	}
-	clientProcessMiss(http);
-	return;
-    }
-    assert(size > 0);
-    mem = e->mem_obj;
-    assert(!EBIT_TEST(e->flags, ENTRY_ABORTED));
-    /* update size of the request */
-    http->reqsize = size + http->reqofs;
-    if (mem->reply->sline.status == 0) {
-	/*
-	 * we don't have full reply headers yet; either wait for more or
-	 * punt to clientProcessMiss.
-	 */
-	if (e->mem_status == IN_MEMORY || e->store_status == STORE_OK) {
-	    clientProcessMiss(http);
-	} else if (size + http->reqofs >= HTTP_REQBUF_SZ && http->out.offset == 0) {
-	    clientProcessMiss(http);
-	} else {
-	    debug(33, 3) ("clientCacheHit: waiting for HTTP reply headers\n");
-	    http->reqofs += size;
-	    assert(http->reqofs <= HTTP_REQBUF_SZ);
-	    storeClientCopy(http->sc, e,
-		http->out.offset + http->reqofs,
-		HTTP_REQBUF_SZ,
-		http->reqbuf + http->reqofs,
-		clientCacheHit,
-		http);
-	}
-	return;
-    }
-    /*
-     * Got the headers, now grok them
-     */
-    assert(http->log_type == LOG_TCP_HIT);
-    switch (varyEvaluateMatch(e, r)) {
-    case VARY_NONE:
-	/* No variance detected. Continue as normal */
-	break;
-    case VARY_MATCH:
-	/* This is the correct entity for this request. Continue */
-	debug(33, 2) ("clientProcessHit: Vary MATCH!\n");
-	break;
-    case VARY_OTHER:
-	/* This is not the correct entity for this request. We need
-	 * to requery the cache.
-	 */
-	http->entry = NULL;
-	storeUnregister(http->sc, e, http);
-	http->sc = NULL;
-	storeUnlockObject(e);
-	/* Note: varyEvalyateMatch updates the request with vary information
-	 * so we only get here once. (it also takes care of cancelling loops)
-	 */
-	debug(33, 2) ("clientProcessHit: Vary detected!\n");
-	clientProcessRequest(http);
-	return;
-    case VARY_CANCEL:
-	/* varyEvaluateMatch found a object loop. Process as miss */
-	debug(33, 1) ("clientProcessHit: Vary object loop!\n");
-	clientProcessMiss(http);
-	return;
-    }
-    if (r->method == METHOD_PURGE) {
-	http->entry = NULL;
-	storeUnregister(http->sc, e, http);
-	http->sc = NULL;
-	storeUnlockObject(e);
-	clientPurgeRequest(http);
-	return;
-    }
-    if (checkNegativeHit(e)) {
-	http->log_type = LOG_TCP_NEGATIVE_HIT;
-	clientSendMoreData(data, buf, size);
-    } else if (r->method == METHOD_HEAD) {
-	/*
-	 * RFC 2068 seems to indicate there is no "conditional HEAD"
-	 * request.  We cannot validate a cached object for a HEAD
-	 * request, nor can we return 304.
-	 */
-	if (e->mem_status == IN_MEMORY)
-	    http->log_type = LOG_TCP_MEM_HIT;
-	clientSendMoreData(data, buf, size);
-    } else if (refreshCheckHTTP(e, r) && !http->flags.internal) {
-	debug(33, 5) ("clientCacheHit: in refreshCheck() block\n");
-	/*
-	 * We hold a stale copy; it needs to be validated
-	 */
-	/*
-	 * The 'need_validation' flag is used to prevent forwarding
-	 * loops between siblings.  If our copy of the object is stale,
-	 * then we should probably only use parents for the validation
-	 * request.  Otherwise two siblings could generate a loop if
-	 * both have a stale version of the object.
-	 */
-	r->flags.need_validation = 1;
-	if (e->lastmod < 0) {
-	    /*
-	     * Previous reply didn't have a Last-Modified header,
-	     * we cannot revalidate it.
-	     */
-	    http->log_type = LOG_TCP_MISS;
-	    clientProcessMiss(http);
-	} else if (r->flags.nocache) {
-	    /*
-	     * This did not match a refresh pattern that overrides no-cache
-	     * we should honour the client no-cache header.
-	     */
-	    http->log_type = LOG_TCP_CLIENT_REFRESH_MISS;
-	    clientProcessMiss(http);
-	} else if (r->protocol == PROTO_HTTP) {
-	    /*
-	     * Object needs to be revalidated
-	     * XXX This could apply to FTP as well, if Last-Modified is known.
-	     */
-	    http->log_type = LOG_TCP_REFRESH_MISS;
-	    clientProcessExpired(http);
-	} else {
-	    /*
-	     * We don't know how to re-validate other protocols. Handle
-	     * them as if the object has expired.
-	     */
-	    http->log_type = LOG_TCP_MISS;
-	    clientProcessMiss(http);
-	}
-    } else if (r->flags.ims) {
-	/*
-	 * Handle If-Modified-Since requests from the client
-	 */
-	if (mem->reply->sline.status != HTTP_OK) {
-	    debug(33, 4) ("clientCacheHit: Reply code %d != 200\n",
-		mem->reply->sline.status);
-	    http->log_type = LOG_TCP_MISS;
-	    clientProcessMiss(http);
-	} else if (modifiedSince(e, http->request)) {
-	    http->log_type = LOG_TCP_IMS_HIT;
-	    clientSendMoreData(data, buf, size);
-	} else {
-	    time_t timestamp = e->timestamp;
-	    MemBuf mb = httpPacked304Reply(e->mem_obj->reply);
-	    http->log_type = LOG_TCP_IMS_HIT;
-	    storeUnregister(http->sc, e, http);
-	    http->sc = NULL;
-	    storeUnlockObject(e);
-	    e = clientCreateStoreEntry(http, http->request->method, null_request_flags);
-	    /*
-	     * Copy timestamp from the original entry so the 304
-	     * reply has a meaningful Age: header.
-	     */
-	    e->timestamp = timestamp;
-	    http->entry = e;
-	    httpReplyParse(e->mem_obj->reply, mb.buf, mb.size);
-	    storeAppend(e, mb.buf, mb.size);
-	    memBufClean(&mb);
-	    storeComplete(e);
-	}
-    } else {
-	/*
-	 * plain ol' cache hit
-	 */
-	if (e->mem_status == IN_MEMORY)
-	    http->log_type = LOG_TCP_MEM_HIT;
-	else if (Config.onoff.offline)
-	    http->log_type = LOG_TCP_OFFLINE_HIT;
-	clientSendMoreData(data, buf, size);
-    }
-}
-
-
-static int
-clientReplyBodyTooLarge(HttpReply * rep, ssize_t clen)
-{
-    if (0 == rep->maxBodySize)
-	return 0;		/* disabled */
-    if (clen < 0)
-	return 0;		/* unknown */
-    if (clen > rep->maxBodySize)
-	return 1;		/* too large */
-    return 0;
-}
-
-static int
-clientRequestBodyTooLarge(int clen)
-{
-    if (0 == Config.maxRequestBodySize)
-	return 0;		/* disabled */
-    if (clen < 0)
-	return 0;		/* unknown, bug? */
-    if (clen > Config.maxRequestBodySize)
-	return 1;		/* too large */
-    return 0;
-}
-
-
-/* Responses with no body will not have a content-type header, 
- * which breaks the rep_mime_type acl, which
- * coincidentally, is the most common acl for reply access lists.
- * A better long term fix for this is to allow acl matchs on the various
- * status codes, and then supply a default ruleset that puts these 
- * codes before any user defines access entries. That way the user 
- * can choose to block these responses where appropriate, but won't get
- * mysterious breakages.
- */
-static int
-clientAlwaysAllowResponse(http_status sline)
-{
-    switch (sline) {
-    case HTTP_CONTINUE:
-    case HTTP_SWITCHING_PROTOCOLS:
-    case HTTP_PROCESSING:
-    case HTTP_NO_CONTENT:
-    case HTTP_NOT_MODIFIED:
-	return 1;
-	/* unreached */
-	break;
-    default:
-	return 0;
-    }
-}
-
-
-/*
- * accepts chunk of a http message in buf, parses prefix, filters headers and
- * such, writes processed message to the client's socket
+ * Write a chunk of data to a client socket. If the reply is present, send the reply headers down the wire too,
+ * and clean them up when finished.
+ * Pre-condition: 
+ *   The request is one backed by a connection, not an internal request.
+ *   data context is null
+ *   There are no more entries in the stream chain.
  */
 static void
-clientSendMoreData(void *data, char *retbuf, ssize_t retsize)
+clientSocketRecipient (clientStreamNode *node, clientHttpRequest *http, HttpReply *rep, const char *body_data, ssize_t body_size)
 {
-    clientHttpRequest *http = data;
-    StoreEntry *entry = http->entry;
-    ConnStateData *conn = http->conn;
-    int fd = conn->fd;
-    HttpReply *rep = NULL;
-    char *buf = http->reqbuf;
-    const char *body_buf = buf;
-    ssize_t size = http->reqofs + retsize;
-    ssize_t body_size = size;
-    MemBuf mb;
-    ssize_t check_size = 0;
-
-    debug(33, 5) ("clientSendMoreData: %s, %d bytes (%d new bytes)\n", http->uri, (int) size, retsize);
-    assert(size <= HTTP_REQBUF_SZ);
-    assert(http->request != NULL);
-    dlinkDelete(&http->active, &ClientActiveRequests);
-    dlinkAdd(http, &http->active, &ClientActiveRequests);
-    debug(33, 5) ("clientSendMoreData: FD %d '%s', out.offset=%ld \n",
-	fd, storeUrl(entry), (long int) http->out.offset);
-    /* update size of the request */
-    http->reqsize = size;
-    if (conn->chr != http) {
-	/* there is another object in progress, defer this one */
-	debug(33, 2) ("clientSendMoreData: Deferring %s\n", storeUrl(entry));
-	return;
-    } else if (http->request->flags.reset_tcp) {
-	comm_reset_close(fd);
-	return;
-    } else if (entry && EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
-	/* call clientWriteComplete so the client socket gets closed */
-	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
-	return;
-    } else if (retsize < 0) {
-	/* call clientWriteComplete so the client socket gets closed */
-	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
-	return;
-    } else if (retsize == 0) {
-	/* call clientWriteComplete so the client socket gets closed */
+    int fd;
+    /* Test preconditions */
+    assert (node != NULL);
+    /* TODO: handle this rather than asserting - it should only ever happen if we cause an abort and the callback chain 
+     * loops back to here, so we can simply return. However, that itself shouldn't happen, so it stays as an assert for now. */
+    assert (cbdataReferenceValid (node));
+    assert (node->data == NULL);
+    assert (node->next == NULL);
+    assert (http->conn && http->conn->fd != -1);
+    fd = http->conn->fd;
+    /* EOF / Read error /  aborted entry */
+    if (rep == NULL && body_data == NULL && body_size == 0) {
 	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
 	return;
     }
-    if (http->out.offset == 0) {
-	if (Config.onoff.log_mime_hdrs) {
-	    size_t k;
-	    if ((k = headersEnd(buf, size))) {
-		safe_free(http->al.headers.reply);
-		http->al.headers.reply = xcalloc(k + 1, 1);
-		xstrncpy(http->al.headers.reply, buf, k);
-	    }
-	}
-	rep = clientBuildReply(http, buf, size);
-	if (rep) {
-	    aclCheck_t *ch;
-	    int rv;
-	    httpReplyBodyBuildSize(http->request, rep, &Config.ReplyBodySize);
-	    if (clientReplyBodyTooLarge(rep, rep->content_length)) {
-		ErrorState *err = errorCon(ERR_TOO_BIG, HTTP_FORBIDDEN);
-		err->request = requestLink(http->request);
-		storeUnregister(http->sc, http->entry, http);
-		http->sc = NULL;
-		storeUnlockObject(http->entry);
-		http->entry = clientCreateStoreEntry(http, http->request->method,
-		    null_request_flags);
-		errorAppendEntry(http->entry, err);
-		httpReplyDestroy(rep);
-		return;
-	    }
-	    body_size = size - rep->hdr_sz;
-	    assert(body_size >= 0);
-	    body_buf = buf + rep->hdr_sz;
-	    debug(33, 3) ("clientSendMoreData: Appending %d bytes after %d bytes of headers\n",
-		(int) body_size, rep->hdr_sz);
-	    ch = aclChecklistCreate(Config.accessList.reply, http->request, NULL);
-	    ch->reply = rep;
-	    rv = aclCheckFast(Config.accessList.reply, ch);
-	    aclChecklistFree(ch);
-	    ch = NULL;
-	    debug(33, 2) ("The reply for %s %s is %s, because it matched '%s'\n",
-		RequestMethodStr[http->request->method], http->uri,
-		rv ? "ALLOWED" : "DENIED",
-		AclMatchedName ? AclMatchedName : "NO ACL's");
-	    if (!rv && rep->sline.status != HTTP_FORBIDDEN
-		&& !clientAlwaysAllowResponse(rep->sline.status)) {
-		/* the if above is slightly broken, but there is no way
-		 * to tell if this is a squid generated error page, or one from
-		 * upstream at this point. */
-		ErrorState *err;
-		err = errorCon(ERR_ACCESS_DENIED, HTTP_FORBIDDEN);
-		err->request = requestLink(http->request);
-		storeUnregister(http->sc, http->entry, http);
-		http->sc = NULL;
-		storeUnlockObject(http->entry);
-		http->entry = clientCreateStoreEntry(http, http->request->method,
-		    null_request_flags);
-		errorAppendEntry(http->entry, err);
-		httpReplyDestroy(rep);
-		return;
-	    }
-	} else if (size < HTTP_REQBUF_SZ && entry->store_status == STORE_PENDING) {
-	    /* wait for more to arrive */
-	    http->reqofs += retsize;
-	    assert(http->reqofs <= HTTP_REQBUF_SZ);
-	    storeClientCopy(http->sc, entry,
-		http->out.offset + http->reqofs,
-		HTTP_REQBUF_SZ - http->reqofs,
-		http->reqbuf + http->reqofs,
-		clientSendMoreData,
-		http);
-	    return;
-	}
-    } else {
+    /* trivial case */
+    if (http->out.offset != 0) {
+	assert(rep == NULL);
 	/* Avoid copying to MemBuf if we know "rep" is NULL, and we only have a body */
 	http->out.offset += body_size;
-	assert(rep == NULL);
-	comm_write(fd, buf, size, clientWriteBodyComplete, http, NULL);
+	comm_write(fd, body_data, body_size, clientWriteBodyComplete, http, NULL);
 	/* NULL because clientWriteBodyComplete frees it */
 	return;
-    }
-    if (http->request->method == METHOD_HEAD) {
+    } else {
+	MemBuf mb;
+	/* write headers and/or body if any */
+	assert(rep || (body_data && body_size));
+	/* init mb; put status line and headers if any */
 	if (rep) {
-	    /* do not forward body for HEAD replies */
-	    body_size = 0;
-	    http->flags.done_copying = 1;
-	} else {
-	    /*
-	     * If we are here, then store_status == STORE_OK and it
-	     * seems we have a HEAD repsponse which is missing the
-	     * empty end-of-headers line (home.mira.net, phttpd/0.99.72
-	     * does this).  Because clientBuildReply() fails we just
-	     * call this reply a body, set the done_copying flag and
-	     * continue...
-	     */
-	    http->flags.done_copying = 1;
-	}
-    }
-    /* write headers and/or body if any */
-    assert(rep || (body_buf && body_size));
-    /* init mb; put status line and headers if any */
-    if (rep) {
-	mb = httpReplyPack(rep);
-	http->out.offset += rep->hdr_sz;
-	check_size += rep->hdr_sz;
+	    mb = httpReplyPack(rep);
+	    http->out.offset += rep->hdr_sz;
 #if HEADERS_LOG
-	headersLog(0, 0, http->request->method, rep);
+	    headersLog(0, 0, http->request->method, rep);
 #endif
-	httpReplyDestroy(rep);
-	rep = NULL;
-    } else {
-	memBufDefInit(&mb);
-    }
-    if (body_buf && body_size) {
-	http->out.offset += body_size;
-	check_size += body_size;
-	memBufAppend(&mb, body_buf, body_size);
+	    httpReplyDestroy(rep);
+	    rep = NULL;
+	} else {
+	    memBufDefInit(&mb);
+	}
+	if (body_data && body_size) {
+	    http->out.offset += body_size;
+	    memBufAppend(&mb, body_data, body_size);
+	}
+	/* write */
+	comm_write_mbuf(fd, mb, clientWriteComplete, http);
+	/* if we don't do it, who will? */
     }
-    /* write */
-    comm_write_mbuf(fd, mb, clientWriteComplete, http);
-    /* if we don't do it, who will? */
 }
 
 /*
@@ -1794,73 +540,45 @@
     }
 }
 
+
+/* A write has just completed to the client, or we have just realised there is
+ * no more data to send.
+ */
 static void
 clientWriteComplete(int fd, char *bufnotused, size_t size, int errflag, void *data)
 {
     clientHttpRequest *http = data;
     StoreEntry *entry = http->entry;
-    int done;
     http->out.size += size;
     debug(33, 5) ("clientWriteComplete: FD %d, sz %ld, err %d, off %ld, len %d\n",
 	fd, (long int) size, errflag, (long int) http->out.offset, entry ? objectLen(entry) : 0);
-    if (size > 0) {
+    if (size > 0 && fd > -1) {
 	kb_incr(&statCounter.client_http.kbytes_out, size);
 	if (isTcpHit(http->log_type))
 	    kb_incr(&statCounter.client_http.hit_kbytes_out, size);
     }
-#if SIZEOF_SIZE_T == 4
-    if (http->out.size > 0x7FFF0000) {
-	debug(33, 1) ("WARNING: closing FD %d to prevent counter overflow\n", fd);
-	debug(33, 1) ("\tclient %s\n", inet_ntoa(http->conn->peer.sin_addr));
-	debug(33, 1) ("\treceived %d bytes\n", (int) http->out.size);
-	debug(33, 1) ("\tURI %s\n", http->log_uri);
-	comm_close(fd);
-    } else
-#endif
-#if SIZEOF_OFF_T == 4
-    if (http->out.offset > 0x7FFF0000) {
-	debug(33, 1) ("WARNING: closing FD %d to prevent counter overflow\n", fd);
-	debug(33, 1) ("\tclient %s\n", inet_ntoa(http->conn->peer.sin_addr));
-	debug(33, 1) ("\treceived %d bytes (offset %d)\n", (int) http->out.size,
-	    (int) http->out.offset);
-	debug(33, 1) ("\tURI %s\n", http->log_uri);
-	comm_close(fd);
-    } else
-#endif
     if (errflag) {
 	/*
-	 * just close the socket, httpRequestFree will abort if needed
+	 * just close the socket, httpRequestFree will abort if needed.
+	 * errflag is only EVER set by the comms callbacks
 	 */
+	assert (fd != -1);
 	comm_close(fd);
-    } else if (NULL == entry) {
-	comm_close(fd);		/* yuk */
-    } else if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
-	comm_close(fd);
-    } else if ((done = clientCheckTransferDone(http)) != 0 || size == 0) {
-	debug(33, 5) ("clientWriteComplete: FD %d transfer is DONE\n", fd);
-	/* We're finished case */
-	if (httpReplyBodySize(http->request->method, entry->mem_obj->reply) < 0) {
+	return;
+    }
+    switch (clientDetermineActionAfterWrite(fd, http, entry, size)){
+      case 0:
 	    debug(33, 5) ("clientWriteComplete: closing, content_length < 0\n");
-	    comm_close(fd);
-	} else if (!done) {
-	    debug(33, 5) ("clientWriteComplete: closing, !done\n");
-	    comm_close(fd);
-	} else if (clientGotNotEnough(http)) {
-	    debug(33, 5) ("clientWriteComplete: client didn't get all it expected\n");
-	    comm_close(fd);
-	} else if (http->request->flags.proxy_keepalive) {
-	    debug(33, 5) ("clientWriteComplete: FD %d Keeping Alive\n", fd);
 	    clientKeepaliveNextRequest(http);
-	} else {
-	    comm_close(fd);
-	}
-    } else if (clientReplyBodyTooLarge(entry->mem_obj->reply, http->out.offset)) {
-	comm_close(fd);
-    } else {
-	/* More data will be coming from primary server; register with 
-	 * storage manager. */
-	if (EBIT_TEST(entry->flags, ENTRY_ABORTED))
-	    debug(33, 0) ("clientWriteComplete 2: ENTRY_ABORTED\n");
+	    return;
+      case 1: /* fallthru */
+      case 2: 
+	    if (fd != -1)
+		comm_close (fd);
+	    return;
+      case 3:
+	    /* More data will be coming from primary server; register with
+	     * storage manager. */
 	http->reqofs = 0;
 	storeClientCopy(http->sc, entry,
 	    http->out.offset,
